#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

namespace NinjaTrader.NinjaScript.Indicators.TraderFox {

	public class RangeCounter2 : Indicator {
		
		private int RangeSize = 0;
		private int BodySize = 0;
		
		NinjaTrader.Gui.Tools.SimpleFont myFont = new NinjaTrader.Gui.Tools.SimpleFont("Courier New", 12) { Size = 12, Bold = true };
		
		protected override void OnStateChange() {
			
			if ( State == State.SetDefaults ) {
				Description					= "";
				Name						= "TF-RangeCounter";
				
				AddPlot( Brushes.Black, "RangeSize" );
				AddPlot( Brushes.Red, "BodySize" );
			}
		}

		protected override void OnBarUpdate() {
			
			if ( CurrentBar == 0 ) {
				Values[0][0] = 0;
				Values[1][0] = 0;
				return;
			}

			
			double Current_Range = High[0] - Low[0];
			RangeSize = 0;
			int l = Math.Min( CurrentBar, 100 );
			for ( int i=0; i<l; i++) {
				if ( Current_Range >= High[i] - Low[i] ) {
					RangeSize++;
				}
			}
		
			double Current_Body = Math.Abs( Close[0] - Open[0] );
			BodySize = 0;
			l = Math.Min( CurrentBar, 100 );
			for ( int i=0; i<l; i++) {
				if ( Current_Body >= Math.Abs( Close[i] - Open[i] ) ) {
					BodySize++;
				}
			}
				
					
			if ( RangeSize > 0 ) {
				Draw.Text( this, "RangeSize " + CurrentBar, false, RangeSize.ToString(), 0, High[0], 6, Brushes.Black, myFont, TextAlignment.Center, Brushes.Transparent, Brushes.Transparent, 0 );
			}
				
			if ( BodySize > 0 ) {
				Draw.Text( this, "BodySize " + CurrentBar, false, BodySize.ToString(), 0, Low[0], -8, Brushes.Red, myFont, TextAlignment.Center, Brushes.Transparent, Brushes.Transparent, 0 );
			}
			
			Values[0][0] = RangeSize;
			Values[1][0] = BodySize;

		}
		
		#region Properties
		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Range {
			get { return Values[0]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Body {
			get { return Values[1]; }
		}
		#endregion

	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private TraderFox.RangeCounter2[] cacheRangeCounter2;
		public TraderFox.RangeCounter2 RangeCounter2()
		{
			return RangeCounter2(Input);
		}

		public TraderFox.RangeCounter2 RangeCounter2(ISeries<double> input)
		{
			if (cacheRangeCounter2 != null)
				for (int idx = 0; idx < cacheRangeCounter2.Length; idx++)
					if (cacheRangeCounter2[idx] != null &&  cacheRangeCounter2[idx].EqualsInput(input))
						return cacheRangeCounter2[idx];
			return CacheIndicator<TraderFox.RangeCounter2>(new TraderFox.RangeCounter2(), input, ref cacheRangeCounter2);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.TraderFox.RangeCounter2 RangeCounter2()
		{
			return indicator.RangeCounter2(Input);
		}

		public Indicators.TraderFox.RangeCounter2 RangeCounter2(ISeries<double> input )
		{
			return indicator.RangeCounter2(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.TraderFox.RangeCounter2 RangeCounter2()
		{
			return indicator.RangeCounter2(Input);
		}

		public Indicators.TraderFox.RangeCounter2 RangeCounter2(ISeries<double> input )
		{
			return indicator.RangeCounter2(input);
		}
	}
}

#endregion
